# -*- coding: utf-8 -*-
# Copyright 2011 Thamini S.à.R.L    This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from report.report_sxw import report_sxw, rml_parse
from base_rml2pdf_extra_tags.report_extra import report_with_attachment

class insurance_contract_report_parser(rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(insurance_contract_report_parser, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'get_selection_string': self.get_selection_string,
        })

    def get_selection_string(self, record, fieldname):
        record_proxy = self.pool.get(record._table._name)
        field_def = record_proxy.fields_get(self.cr, self.uid, [fieldname], context=self.localcontext)[fieldname]
        field_selection_dict = dict(field_def['selection'])
        field_value = getattr(record, fieldname)
        return field_selection_dict.get(field_value, u'')

class insurance_contract_report_sxw(report_with_attachment, report_sxw):
    def get_attachment_data(self, cr, uid, record, context=None):
        attachment_ids = []
        policyholder_lang_code = record.policyholder_id.lang
        for attach in record.type_id.specific_conditions_attachments:
            if not attach.lang_id or attach.lang_id.code == policyholder_lang_code:
                attachment_ids.append(attach.attachment_id.id)
        return self.get_attachment_data_from_attachment_ids(cr, uid, attachment_ids, context)

insurance_contract_report_sxw(
           'report.insurance.contract.report',
           'insurance.contract',
           'addons/insurance/report/insurance_contract_report.rml',
           parser=insurance_contract_report_parser,
           header=True)
