# -*- coding: utf-8 -*-
# Copyright 2011 Thamini S.à.R.L    This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from datetime import datetime
from osv import osv
from osv import fields
import netsvc

class insurance_contract_renew_wizard(osv.osv_memory):
    _name = 'insurance.contract.renew.wizard'
    _columns = {
    }

    def button_renew(self, cr, uid, ids, context=None):
        if not context:
            return {} # XXX: should we raise exception?
        contract_id = context.get('active_id')
        if not contract_id:
            return {}
        contract_proxy = self.pool.get('insurance.contract')
        contract = contract_proxy.browse(cr, uid, contract_id, context=context)
        new_contract_data = {
            'start_date': False,
            'end_date': False,
            'version': contract.version + 1,
        }
        new_contract_id = contract_proxy.copy(cr, uid, contract.id, context=context)
        contract_proxy.write(cr, uid, new_contract_id, new_contract_data, context=context)

        workflow = netsvc.LocalService('workflow')
        workflow.trg_validate(uid, contract_proxy._name, contract.id, 'signal_deprecate', cr)
        return {}

insurance_contract_renew_wizard()
